Clerk billing for B2B SaaS
Clerk billing for B2B SaaS allows you to create plans and manage subscriptions for companies or organizations in your application. If you'd like to charge individual users, see Billing for B2C SaaS. You can also combine both B2C and B2B billing in the same application.
Enable billing
To enable billing for your application, navigate to the Billing Settings page in the Clerk Dashboard. This page will guide you through enabling billing for your application.
Clerk billing costs just 0.7% per transaction, plus Stripe's transaction fees which are paid directly to Stripe. Clerk Billing is not the same as Stripe Billing. Plans and pricing are managed directly through the Clerk Dashboard and won't sync with your existing Stripe products or plans. Clerk uses Stripe only for payment processing, so you don't need to set up Stripe Billing.
Payment gateway
Once you have enabled billing, you will see the following Payment gateway options for collecting payments via Stripe:
- Clerk development gateway: A shared test Stripe account so developers can get started testing and building with billing in development without needing to create and configure a Stripe account.
- Stripe account: Use your own Stripe account.
Create a plan
Subscription plans are what your customers subscribe to. There is no limit to the number of plans you can create. If your Clerk instance has existing custom permissions, the corresponding features from those permissions will automatically be added to the free plan for orgs. This ensures that organization members get the same set of custom permissions when billing is enabled, because all organizations start on the free plan.
To create a plan, navigate to the Plans page in the Clerk Dashboard. Here, you can create, edit, and delete plans. To setup B2B billing, select the Plans for Organizations tab and select Add Plan. When creating a plan, you can also create features for the plan; see the next section for more information.
Add features to a plan
Features make it easy to give entitlements to your plans. You can add any number of features to a plan.
You can add a feature to a plan when you are creating a plan. To add it after a plan is created:
- Navigate to the Plans page in the Clerk Dashboard.
- Select the plan you'd like to add a feature to.
- In the Features section, select Add Feature.
Create a pricing page
You can create a pricing page by using the <PricingTable /> component. This component displays a table of plans and features that customers can subscribe to. It's recommended to create a dedicated page, as shown in the following example.
import { PricingTable } from '@clerk/clerk-react'
export default function PricingScreen() {
  return (
    <div style={{ maxWidth: '800px', margin: '0 auto', padding: '0 1rem' }}>
      <PricingTable for="organization" />
    </div>
  )
}Control access with features, plans, and permissions
You can use Clerk's features, plans, and permissions to gate access to content using . There are a few ways to do this, but the recommended approach is to either use the method or the <Protect> component.
The has() method is available for any JavaScript-based framework, while <Protect> is a component, and therefore, is only available for React-based frameworks.
Example: Using has()
Use the has() method to test if the organization has access to a plan:
const hasPremiumAccess = has({ plan: 'gold' })Or a feature:
const hasPremiumAccess = has({ feature: 'widgets' })The  method is a server-side helper that checks if the organization has been granted a specific type of access control (role, permission, feature, or plan) and returns a boolean value. has() is available on the , which you will access differently .
The following example demonstrates how to use has() to check if an organization has a plan.
import { useAuth } from '@clerk/clerk-react'
export default function BronzeContentPage() {
  const { has, isLoaded } = useAuth()
  if (!isLoaded) return <div>Loading...</div>
  const hasBronzePlan = has({ plan: 'bronze' })
  if (!hasBronzePlan) return <h1>Only subscribers to the Bronze plan can access this content.</h1>
  return <h1>For Bronze subscribers only</h1>
}The following example demonstrates how to use has() to check if an organization has a feature.
import { useAuth } from '@clerk/clerk-react'
export default function PremiumContentPage() {
  const { isLoaded, has } = useAuth()
  if (!isLoaded) return <div>Loading...</div>
  const hasPremiumAccess = has({ feature: 'premium_access' })
  if (!hasPremiumAccess)
    return <h1>Only subscribers with the Premium Access feature can access this content.</h1>
  return <h1>Our Exclusive Content</h1>
}The following example demonstrates how to use has() to check if an organization has a permission.
import { useAuth } from '@clerk/clerk-react'
export default function ManagePremiumContentPage() {
  const { has, isLoaded } = useAuth()
  if (!isLoaded) return <div>Loading...</div>
  const hasPremiumAccessManage = has({ permission: 'org:premium_access:manage' })
  if (!hasPremiumAccessManage)
    return (
      <h1>Only subscribers with the Premium Access Manage permission can access this content.</h1>
    )
  return <h1>Our Exclusive Content</h1>
}Example: Using <Protect>
The <Protect> component protects content or even entire routes by checking if the organization has been granted a specific type of access control (role, permission, feature, or plan). You can pass a fallback prop to <Protect> that will be rendered if the organization does not have the access control.
The following example demonstrates how to use <Protect> to protect a page by checking if the organization has a plan.
import { Protect } from '@clerk/clerk-react'
export default function ProtectedContentPage() {
  return (
    <Protect
      plan="bronze"
      fallback={<p>Only subscribers to the Bronze plan can access this content.</p>}
    >
      <h1>Exclusive Bronze Content</h1>
      <p>This content is only visible to Bronze subscribers.</p>
    </Protect>
  )
}The following example demonstrates how to use <Protect> to protect a page by checking if the organization has a feature.
import { Protect } from '@clerk/clerk-react'
export default function ProtectedPremiumContentPage() {
  return (
    <Protect
      feature="premium_access"
      fallback={<p>Only subscribers with the Premium Access feature can access this content.</p>}
    >
      <h1>Exclusive Premium Content</h1>
      <p>This content is only visible to users with Premium Access feature.</p>
    </Protect>
  )
}The following example demonstrates how to use <Protect> to protect a page by checking if the organization has a permission.
import { Protect } from '@clerk/clerk-react'
export default function ProtectedManageContentPage() {
  return (
    <Protect
      permission="premium_access:manage"
      fallback={
        <p>Only subscribers with the Premium Access Manage permission can access this content.</p>
      }
    >
      <h1>Exclusive Management Content</h1>
      <p>This content is only visible to users with Premium Access Manage permission.</p>
    </Protect>
  )
}Feedback
Last updated on

Clerk billing for B2B SaaS
Clerk billing for B2B SaaS allows you to create plans and manage subscriptions for companies or organizations in your application. If you'd like to charge individual users, see Billing for B2C SaaS. You can also combine both B2C and B2B billing in the same application.
Enable billing
To enable billing for your application, navigate to the Billing Settings page in the Clerk Dashboard. This page will guide you through enabling billing for your application.
Clerk billing costs just 0.7% per transaction, plus Stripe's transaction fees which are paid directly to Stripe. Clerk Billing is not the same as Stripe Billing. Plans and pricing are managed directly through the Clerk Dashboard and won't sync with your existing Stripe products or plans. Clerk uses Stripe only for payment processing, so you don't need to set up Stripe Billing.
Payment gateway
Once you have enabled billing, you will see the following Payment gateway options for collecting payments via Stripe:
- Clerk development gateway: A shared test Stripe account so developers can get started testing and building with billing in development without needing to create and configure a Stripe account.
- Stripe account: Use your own Stripe account.
Create a plan
Subscription plans are what your customers subscribe to. There is no limit to the number of plans you can create. If your Clerk instance has existing custom permissions, the corresponding features from those permissions will automatically be added to the free plan for orgs. This ensures that organization members get the same set of custom permissions when billing is enabled, because all organizations start on the free plan.
To create a plan, navigate to the Plans page in the Clerk Dashboard. Here, you can create, edit, and delete plans. To setup B2B billing, select the Plans for Organizations tab and select Add Plan. When creating a plan, you can also create features for the plan; see the next section for more information.
Add features to a plan
Features make it easy to give entitlements to your plans. You can add any number of features to a plan.
You can add a feature to a plan when you are creating a plan. To add it after a plan is created:
- Navigate to the Plans page in the Clerk Dashboard.
- Select the plan you'd like to add a feature to.
- In the Features section, select Add Feature.
Create a pricing page
You can create a pricing page by using the <PricingTable /> component. This component displays a table of plans and features that customers can subscribe to. It's recommended to create a dedicated page, as shown in the following example.
<script setup lang="ts">
import { PricingTable } from '@clerk/vue'
</script>
<template>
  <main>
    <PricingTable for="organization" />
  </main>
</template>Control access with features, plans, and permissions
You can use Clerk's features, plans, and permissions to gate access to content using . There are a few ways to do this, but the recommended approach is to either use the method or the <Protect> component.
The has() method is available for any JavaScript-based framework, while <Protect> is a component, and therefore, is only available for React-based frameworks.
Example: Using has()
Use the has() method to test if the organization has access to a plan:
const hasPremiumAccess = has({ plan: 'gold' })Or a feature:
const hasPremiumAccess = has({ feature: 'widgets' })The  method is a server-side helper that checks if the organization has been granted a specific type of access control (role, permission, feature, or plan) and returns a boolean value. has() is available on the , which you will access differently .
The following example demonstrates how to use has() to check if an organization has a plan.
<script setup lang="ts">
import { useAuth } from '@clerk/vue'
import { computed } from 'vue'
const { isLoaded, has } = useAuth()
const hasBronzePlan = computed(() => has.value?.({ plan: 'bronze' }))
</script>
<template>
  <main>
    <div v-if="!isLoaded">Loading...</div>
    <h1 v-else-if="!hasBronzePlan">Only subscribers to the Bronze plan can access this content.</h1>
    <h1 v-else>For Bronze subscribers only</h1>
  </main>
</template>The following example demonstrates how to use has() to check if an organization has a feature.
<script setup lang="ts">
import { useAuth } from '@clerk/vue'
import { computed } from 'vue'
const { isLoaded, has } = useAuth()
const hasPremiumAccess = computed(() => has.value?.({ feature: 'premium_access' }))
</script>
<template>
  <main>
    <div v-if="!isLoaded">Loading...</div>
    <h1 v-else-if="!hasPremiumAccess">
      Only subscribers with the Premium Access feature can access this content.
    </h1>
    <h1 v-else>Our Exclusive Content</h1>
  </main>
</template>The following example demonstrates how to use has() to check if an organization has a permission.
<script setup lang="ts">
import { useAuth } from '@clerk/vue'
import { computed } from 'vue'
const { isLoaded, has } = useAuth()
const hasPremiumAccessManage = computed(() =>
  has.value?.({ permission: 'org:premium_access:manage' }),
)
</script>
<template>
  <main>
    <div v-if="!isLoaded">Loading...</div>
    <h1 v-else-if="!hasPremiumAccessManage">
      Only subscribers with the Premium Access Manage permission can access this content.
    </h1>
    <h1 v-else>Our Exclusive Content</h1>
  </main>
</template>Example: Using <Protect>
The <Protect> component protects content or even entire routes by checking if the organization has been granted a specific type of access control (role, permission, feature, or plan). You can pass a fallback prop to <Protect> that will be rendered if the organization does not have the access control.
The following example demonstrates how to use <Protect> to protect a page by checking if the organization has a plan.
<script setup lang="ts">
import { Protect } from '@clerk/vue'
</script>
<template>
  <main>
    <Protect plan="bronze" fallback="Only subscribers to the Bronze plan can access this content.">
      <h1>Exclusive Bronze Content</h1>
      <p>This content is only visible to Bronze subscribers.</p>
    </Protect>
  </main>
</template>The following example demonstrates how to use <Protect> to protect a page by checking if the organization has a feature.
<script setup lang="ts">
import { Protect } from '@clerk/vue'
</script>
<template>
  <main>
    <Protect
      feature="premium_access"
      fallback="Only subscribers with the Premium Access feature can access this content."
    >
      <h1>Exclusive Premium Content</h1>
      <p>This content is only visible to users with Premium Access feature.</p>
    </Protect>
  </main>
</template>The following example demonstrates how to use <Protect> to protect a page by checking if the organization has a permission.
<script setup lang="ts">
import { Protect } from '@clerk/vue'
</script>
<template>
  <main>
    <Protect
      permission="premium_access:manage"
      fallback="Only subscribers with the Premium Access Manage permission can access this content."
    >
      <h1>Exclusive Management Content</h1>
      <p>This content is only visible to users with Premium Access Manage permission.</p>
    </Protect>
  </main>
</template>Feedback
Last updated on